unit re_iis_redirect_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, HTTPApp,ExtCtrls,pbs,graphics,jpeg;

const
  temppath='c:\temp\';
  log=temppath+'re_cam.log';
  Max_log_length=200;

type
  fileinfo=record
  name:string;
  creation_dtm:tdatetime;
  size:integer;
end;

type
  TMain_WebModule = class(TWebModule)
    procedure Main_WebModuleDef_WebActionItemAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure mainlog(t:string);
    function info_page:string;
    procedure Main_WebModulelog_WebActionItemAction(Sender: TObject;
      Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
    procedure WebModuleCreate(Sender: TObject);
    procedure WebModuleDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Main_WebModule: TMain_WebModule;
  modulePath:string;
  LogMemo: Tstringlist;

implementation

{$R *.DFM}

procedure TMain_WebModule.mainlog(t:string);
begin
while pos(#13,t)<>0 do
    delete(t,pos(#13,t),1);
while pos(#10,t)<>0 do
    delete(t,pos(#10,t),1);
try
  logmemo.BeginUpdate;
  if length(t)>0 then
     if length(t)>2 then
        logmemo.Append(datetimetostr(now)+' '+t)
     else
        logmemo.Append('');
  while logmemo.Count>Max_log_length do
        logmemo.Delete(0);
  logmemo.SaveToFile(log);
except
end;
end;

function TMain_WebModule.info_page:string;
var
temp:string;
begin
   result:='';
   temp:=logmemo.Text;
   temp:=swap_in_str(temp,#13,#10);
   temp:=swap_in_str(temp,#10#10,#10);
   temp:=swap_in_str(temp,#10,'<br>');
   result:='<html>Log:<br>'+temp+'</html>';
end;

procedure TMain_WebModule.Main_WebModuleDef_WebActionItemAction(
  Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
VAR
  Jpeg: TJpegImage;
  MemStr: TMemoryStream;
  sr: TSearchRec;
  FileAttrs: Integer;
  j,i,k:integer;
  imgs:array of fileinfo;
  timg:fileinfo;

 function FileTimeToDateTime(FileTime: TFileTime): TDateTime;
 var
   ModifiedTime: TFileTime;
   SystemTime: TSystemTime;
 begin
   Result := 0;
   try
     FileTimeToLocalFileTime(FileTime, ModifiedTime);
     FileTimeToSystemTime(ModifiedTime, SystemTime);
     Result := SystemTimeToDateTime(SystemTime);
   except
   end;
 end;

begin
mainlog('----  ');
mainlog('Request.RemoteAddr:'+Request.RemoteAddr);
try
  setlength(imgs,0);
  FileAttrs:=faAnyFile-faDirectory;
  if FindFirst(modulePath+'*.jpg', FileAttrs, sr) = 0 then
                  try
                      setlength(imgs,length(imgs)+1);
                      imgs[high(imgs)].name:=sr.Name;
                      imgs[high(imgs)].creation_dtm:=FileTimeToDateTime(sr.FindData.ftCreationTime);
                      imgs[high(imgs)].size:=sr.Size;
                      while (FindNext(sr) = 0) do
                        begin
                        setlength(imgs,length(imgs)+1);
                        imgs[high(imgs)].name:=sr.Name;
                        imgs[high(imgs)].creation_dtm:=FileTimeToDateTime(sr.FindData.ftCreationTime);
                        imgs[high(imgs)].size:=sr.Size;
                        end;
                  finally
                      FindClose(sr);
                  end;
  mainlog('found '+inttostr(length(imgs))+' imgs!');
  if length(imgs)>0 then
    begin
    if length(imgs)>1 then
       begin
       for i:=low(imgs) to high(imgs)-1 do
           for j:=i+1 to high(imgs) do
              if imgs[j].creation_dtm>imgs[i].creation_dtm then
                 begin
                 timg:=imgs[j];
                 imgs[j]:=imgs[i];
                 imgs[i]:=timg;
                 end;
       for i:=low(imgs) to high(imgs) do
           mainlog('img'+inttostr(i)+':'+imgs[i].name+' C_DTM:'+datetimetostr(imgs[i].creation_dtm)+' size:'+inttostr(imgs[i].size));
      end;
    i:=low(imgs);
    while imgs[i].size<1000 do
      inc(i);
    mainlog('  :');
    mainlog('img'+inttostr(i)+':'+imgs[i].name+' C_DTM:'+datetimetostr(imgs[i].creation_dtm)+' size:'+inttostr(imgs[i].size));

    //  JPEG-     
    Jpeg := TJpegImage.Create;
    try
      while i<high(imgs) do
        try
         Jpeg.LoadFromFile(modulepath+imgs[i].name);
         i:=high(imgs);
        except
         inc(i);
         mainlog('  !  :');
         mainlog('img'+inttostr(i)+':'+imgs[i].name+' C_DTM:'+datetimetostr(imgs[i].creation_dtm)+' size:'+inttostr(imgs[i].size));
        end;
      MemStr := TMemoryStream.Create; //   
      try
        //       
        Jpeg.SaveToStream (MemStr);
        //mainlog('Stream size='+inttostr(MemStr.Size));
        MemStr.Position := 0;
        Response.ContentType := 'image/jpeg';
        Response.ContentStream := MemStr;  //  
        Response.SendResponse;
        Handled:=true;
      finally
        MemStr.Free;
      end;
    finally
      Jpeg.Free;
    end;
    end;
except
end;
end;

procedure TMain_WebModule.Main_WebModulelog_WebActionItemAction(
  Sender: TObject; Request: TWebRequest; Response: TWebResponse;
  var Handled: Boolean);
begin
mainlog('----   ');
mainlog('Request.RemoteAddr:'+Request.RemoteAddr);
Response.Content:=info_page;
end;

procedure TMain_WebModule.WebModuleCreate(Sender: TObject);
var
Path: array[0..MAX_PATH - 1] of Char;
fl:boolean;
i:integer;
begin
try
   SetString(modulePath, Path, GetModuleFileName(HInstance, Path, SizeOf(Path)));
   modulePath:= ExtractFilePath(modulePath);
   LogMemo:=Tstringlist.Create;
   logmemo.Clear;
   try
      logmemo.LoadFromFile(log);
   except
   end;
   mainlog('------------------------------------------');
   mainlog(' ');
   mainlog('modulePath='+modulePath);
except
end;
end;

procedure TMain_WebModule.WebModuleDestroy(Sender: TObject);
begin
   mainlog(' ');
   LogMemo.Free;
end;

end.
